import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrBookassigntask {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  BookId!: IType<number, bigint>;
  BookPageId!: IType<number, bigint>;
  BookPageQuestionId!: IType<number, bigint>;
  OperatorId?: IType<number, bigint>;
  OperatorType!: number;
  Status!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrBookassigntaskSchema = defineEntity({
  class: IcrBookassigntask,
  comment: '录入/审查',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    BookId: p.bigint().name('BookId').columnType('bigint').comment('书Id'),
    BookPageId: p.bigint().name('BookPageId').columnType('bigint').comment('书页id'),
    BookPageQuestionId: p.bigint().name('BookPageQuestionId').columnType('bigint').comment('书页id'),
    OperatorId: p.bigint().name('OperatorId').columnType('bigint').nullable().comment('操作人Id'),
    OperatorType: p.integer().name('OperatorType').comment('操作人类型(1-录入 2-审核 3-补充)'),
    Status: p.integer().name('Status').comment('状态(0-未完成 1完成)'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
